import { Action, ActionCreator, ActionReducer, ReducerTypes } from "@ngrx/store";
import { PatchActionReducer, Segmenter, WiederConfig } from "./config";
import { UndoRedoState } from "./undo-redo.state";
export interface UndoRedo {
    createUndoRedoReducer: <S extends UndoRedoState, A extends Action = Action>(initialState: S, ...ons: ReducerTypes<S, ActionCreator[]>[]) => ActionReducer<S, A>;
    createSegmentedUndoRedoReducer: <S extends UndoRedoState, A extends Action = Action>(initialState: S, segmenter: Segmenter<S>, ...ons: ReducerTypes<S, ActionCreator[]>[]) => ActionReducer<S, A>;
    wrapReducer: <S extends UndoRedoState, A extends Action = Action>(reducer: PatchActionReducer<S, A>, segmenter?: Segmenter<S>) => ActionReducer<S, A>;
}
export declare const undoRedo: (config?: WiederConfig) => UndoRedo;
